/*								sockett.cpp: main program file

	This file is not distributed under the GNU public license (I dont know what that is anyway), 
	it is absolutely free.
	As long as you are maintainig some note that you stole this code from me, you are allowed to use it.

	derDoc																		derDoc@gmx.net
																		members.xoom.com/derDoc
*/

#include "stdafx.h"
#include <Stdio.h>
#include <richedit.h>

#include "Csocket.h"
#include "sockett.h"
#include "Options.h"
#include "selbst.h"
#include "resource.h"





int CALLBACK MainDlgProc(HWND HDlg, UINT Msg, WPARAM wparam, LPARAM lparam);
void CreatePropertySheet(HWND hwndParent, HINSTANCE hInst);

DWORD WINAPI FileSendProc(PVOID pParam);
DWORD WINAPI FileRecvProc(PVOID pParam);

int PreSend(char *text, int i, HWND hdlg, CsocketPtr lps,struct sockaddr_in *sa);
void PreSendFile(CsocketPtr cs, HWND hdlg,struct sockaddr_in *sa);
void PreRecvFile(CsocketPtr cs, HWND hdlg,bool budp);
void InitializeOFN(LPOPENFILENAME ofn,bool type);
int CALLBACK ScanProc(HWND HDlg, UINT Msg, WPARAM wparam, LPARAM lparam);
char *i2a(char zahl, char *pBuff);
char a2i(char *pBuff, int *len);


HANDLE	g_hFile			= NULL;
bool	g_bData = false, g_bFile=false, g_bRFile=false ,g_bStillLis=false;
DWORD	g_FilePointer;
int		g_lPort			= 0;
bool	g_1sec			= false;
bool	btelnet			= false;
		

extern OPTIONS Options;

int IPsCount=0, PortsCount=0;
char *Ports[] = {"20","21","23","80","134","135","139","1001","4800","31337","65000"};
char *Translate[] = {"NUL","SOH","STX","ETX","EOT","ENQ","ACK","BEL","BS","HT","LF","VT","FF","CR","SO","SI","DLE","DC1","DC2","DC3","DC4","NAK","SYN","ETB","CAN","EM","SUB","ESC","FS","GS","RS","US"};

THREADPARAMS TP = {0,NULL,NULL,NULL,false,false,0,0,0,false,NULL}; 
DLGPARAMS DP = {NULL,NULL,0};

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{

	HINSTANCE hDll;

	hDll = LoadLibrary(TEXT("Riched32.dll"));
	sscanf(lpCmdLine, TEXT("%s %s"), DP.IP, DP.port); 
	DP.hInst = hInstance;	
	DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_MAIN), 0, MainDlgProc, (LPARAM)&DP);
	
	FreeLibrary(GetModuleHandle(TEXT("Riched32.dll")));

	return 0;
}



int CALLBACK MainDlgProc(HWND HDlg,UINT Msg,WPARAM wparam,LPARAM lparam)
{
	static CsocketPtr gSocket;
	static CsocketPtr lisSocket;
	static HINSTANCE hInstance;
	static int nw,nh,ow,oh;
	static char g_currentOldestIP=-1,g_currentOldestPort=-1;
	static POINT WPts[20];
	short port;
	int i;
	char *ip, status[255];
	ip=(char *)malloc(15);
	static bool budp=false;
	static struct sockaddr_in sa= {0,0,0,NULL};
	
	
	switch (Msg)
	{
	case WM_INITDIALOG:
	
		
		HANDLE hFile;
		RECT rc;
	
		DWORD read;
		DLGPARAMS *dp;
		dp = (DLGPARAMS *)lparam;

		hInstance = (HINSTANCE)dp->hInst;
		Options.mainh=HDlg;

		
		(CsocketPtr) gSocket = new Csocket((HWND)HDlg,WM_UNOTIFY);  //new Csocket class
		if (!gSocket){
			EndDialog(HDlg, 0);
			return true;
		}
		
		if (!gSocket->bWSAstarted){   //WSA not poroperly initialized
			delete(gSocket);
			EndDialog(HDlg, 0);
			MessageBox(HDlg, TEXT("Could not initialize Windows Sockets 2.0"), TEXT("error"), MB_ICONERROR|MB_OK);
			return true;
		}

		GetClientRect(HDlg, &rc);
		ow=nw=rc.right;		
		oh=nh=rc.bottom;
		
		//Store Window Positions relative to Parent:
		for (i=0;i<21;i++){
			GetWindowRect(GetDlgItem(HDlg,i+1000), &rc);    //Window rect of Child
			WPts[i].x=rc.left; WPts[i].y=rc.top;			//store in array, upper left corner
			ScreenToClient(HDlg, &WPts[i]);					//relative to DialogBox
		}


		//add ports:
		for (i=0;i<9;i++) SendDlgItemMessage(HDlg, IDC_PORT, CB_ADDSTRING, 0,(LPARAM)Ports[i]);
		
		HOSTENT *he;
		//IN_ADDR in;
		
		if (!gethostname(ip, 255)){      //get local host name
			if (he=gethostbyname((const char FAR *)ip)){       //translate to IP
				
				//in.S_un.S_addr = (unsigned long)he->h_addr_list[0];
				ip = inet_ntoa (*(struct in_addr *)*he->h_addr_list);
				//strcpy(ip, in);
				wsprintf(status, TEXT("local IP: %s"), ip);
				SetDlgItemText(HDlg, IDC_STATUS, status);
			}
		}

		//get currentOldestIP/Port:
		hFile = CreateFile(TEXT("sockett.exe"), GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE,
			NULL, OPEN_EXISTING, 0, NULL);
	
		if (hFile != INVALID_HANDLE_VALUE){
			DWORD fs,read;
			if (fs=GetFileSize(hFile, NULL)){
				SetFilePointer(hFile,(signed long)-2,NULL,FILE_END);
				ReadFile(hFile,(LPVOID)&g_currentOldestIP,1,&read,NULL);
				ReadFile(hFile,(LPVOID)&g_currentOldestPort,1,&read,NULL);
			}
		}
		CloseHandle(hFile);
		
		
		if (dp->IP){       //IP in CmdLine?

			SetDlgItemText(HDlg, IDC_IP, (char *)dp->IP);   //set IP  
			if (dp->port){									//Port in CmdLine?
				SetDlgItemText(HDlg, IDC_PORT, dp->port);   //set Port
					
				if (GetDlgItemText(HDlg, IDC_IP, ip, 255))    //not a ""string set?
					SendMessage(HDlg, WM_COMMAND, MAKEWPARAM(IDC_CONNECT,0),0);  //connect()
				
					
			}
		}
		//en/disable controls, set focus to IP
		SetFocus(GetDlgItem(HDlg, IDC_IP));
		EnableWindow(GetDlgItem(HDlg, IDC_SEND), false);
		EnableWindow(GetDlgItem(HDlg, IDC_BUTT_SEND), false);
		EnableWindow(GetDlgItem(HDlg, IDC_SENDFILE), false);
		EnableWindow(GetDlgItem(HDlg, IDC_RECVFILE), false);
		CheckRadioButton(HDlg, IDC_TCP, IDC_UDP, (budp?IDC_UDP:IDC_TCP));
		
		

						
		hFile = CreateFile(TEXT("sockett.ini"), GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE,
			NULL, OPEN_ALWAYS, 0, NULL);
		if (hFile != INVALID_HANDLE_VALUE){
			g_hFile = hFile;
			if (GetFileSize(hFile, NULL)){

				char *pIP = (char *)malloc(16);
			
				
				do{
					ReadFile(hFile, (LPVOID)pIP, 16, &read, NULL);      //read IP
					if (*pIP!=13)
						SendDlgItemMessage(HDlg, IDC_IP, CB_ADDSTRING, 0, (LPARAM)pIP);   //add IP
					SetFilePointer(hFile, 2, NULL, FILE_CURRENT);
					IPsCount++;
				}while (*pIP!=13);
				
				IPsCount--;
				SetFilePointer(hFile, (IPsCount*18+2), NULL, 0);
				
				do{
					
					ReadFile(hFile, (LPVOID)pIP, 6, &read, NULL);      //read Port
					if (*pIP!=13)
						SendDlgItemMessage(HDlg, IDC_PORT, CB_ADDSTRING, 0, (LPARAM)pIP);   //add Port
					SetFilePointer(hFile, 2, NULL, FILE_CURRENT);
					PortsCount++;
				}while (*pIP!=13);
				PortsCount--;
				SetFilePointer(hFile, 0, NULL, FILE_BEGIN);
			}				
		}
	
		return false;

	case WM_CLOSE:

		gSocket->~Csocket();
		if (g_bStillLis) lisSocket->~Csocket();
		delete(gSocket);
		delete(lisSocket);
		free(ip);
		EndDialog(HDlg, 0);
		return true;


	case WM_SETFOCUS:

		SetFocus(GetDlgItem(HDlg, (gSocket->bConnected ? IDC_SEND : IDC_IP)));
		return true;

		
	case WM_WINDOWPOSCHANGING:

		WINDOWPOS *wp;
		wp = (WINDOWPOS *)lparam;
		
		if (wp->hwnd==HDlg){
			if (wp->cy<MINY) wp->cy=MINY;
			if (wp->cx<MINX) wp->cx=MINX;
		}
		return true;


	case WM_SIZE:

		if (wparam==SIZE_RESTORED){

			RECT rc;
			
			HWND hw;
			int high,width,x;
			GetWindowRect(HDlg, &rc);
			
								
			for (i=0;i<21;i++){
				GetWindowRect((hw=GetDlgItem(HDlg, i+1000)), &rc);	//Rect of current Child(hw)
				if (i<18){                //hw needs to stay in its old vert. place
					high=rc.bottom-rc.top;
					width=(rc.right-rc.left);
					x=WPts[i].x;
					if (!i) high+=HIWORD(lparam)-nh;   //hw is MAIN, i.e. the big text window
														//that means the high has to be altered
					if (i<5) width+=(LOWORD(lparam)-nw);  //hw is to be altered in horiz. size
					//in caseschyou wonder,5,6 are texts "IP:"&"port:"
					else if(i>6) x+=LOWORD(lparam)-ow;		//hw is to move to the right
					MoveWindow(hw, x, WPts[i].y,	    //move to new parent pos+relative
						width, high, true); 
				}
				else{									//help,stat and opts need to move downwards
					width=(rc.right-rc.left);
					x=WPts[i].x;
					if (i==20) width+=(LOWORD(lparam)-nw);       //STATUS has to be horiz. resized 
					else x+=LOWORD(lparam)-ow;
					MoveWindow(hw, x, (WPts[i].y+(HIWORD(lparam)-oh)),    //move to new parent pos+relative
						width, (rc.bottom-rc.top), true);
				}//end else
			}//end for
		
			GetClientRect(HDlg, &rc);
			nw=rc.right;					//new Client size
			nh=rc.bottom;
			InvalidateRect(HDlg, NULL,false);
			UpdateWindow(HDlg);
		}//end if ==size_restored
		return false;

	case RECV_STOPPED:

		//reactivate notification:
		WSAAsyncSelect(gSocket->s,HDlg, WM_UNOTIFY, FD_READ|FD_CONNECT|FD_WRITE|FD_ACCEPT);

		return true;

	case WM_COMMAND:

		switch (LOWORD(wparam))
		{
		
		case IDC_OPTIONS:

			CreatePropertySheet(HDlg, hInstance);
			return true;
	
		case IDC_SENDFILE:
			
			OPENFILENAME ofn;
			

			ofn.hwndOwner=HDlg;
			ofn.lpstrFile = TP.FullName;
			ofn.lpstrFileTitle=TP.Name;
			InitializeOFN(&ofn,true);
			ofn.lStructSize=sizeof(ofn);
			
			if (GetOpenFileName(&ofn))
				PreSendFile(gSocket, HDlg,&sa);							
				
			return true;

		case IDC_RECVFILE:
			
			
			

			ofn.hwndOwner=HDlg;
			ofn.lpstrFile = TP.FullName;
			ofn.lpstrFileTitle=TP.Name;
			InitializeOFN(&ofn,false);
			ofn.lStructSize=sizeof(ofn);
			
			if (GetOpenFileName(&ofn))
				PreRecvFile(gSocket, HDlg,budp);
			SetDlgItemText(HDlg, IDC_STATUS, "waiting for transfer to start...");
				
			return true;

		/*case IDC_SCAN:

			CreateDialog(hInstance,MAKEINTRESOURCE(IDD_SCAN),HDlg,ScanProc);
			return true;
		*/
		case IDC_TELNET:

			btelnet= !(btelnet);
			CheckDlgButton(HDlg, IDC_TELNET, btelnet);
			if (lparam!=SENDBY_GENERAL){
				Options.o_bAddCR=btelnet;
				Options.o_bAddLF=btelnet;
			}
			return true;

		case IDC_TCP:

			budp=!budp;
			CheckRadioButton(HDlg, IDC_TCP, IDC_UDP, (budp?IDC_UDP:IDC_TCP));
			return true;
	
		case IDC_UDP:

			budp=!budp;
			CheckRadioButton(HDlg, IDC_TCP, IDC_UDP, (budp?IDC_UDP:IDC_TCP));
			return true;

		case IDC_CONNECT:

			bool bFalse, bTemp,found;
			found=false;
		
			bFalse = false;       //falseIP = false, to start with
			if (!(GetDlgItemText(HDlg, IDC_IP, ip, 255))){         //no text in IP-Box?

				SetDlgItemText(HDlg, IDC_STATUS, TEXT("no IP specified!"));
				SetTimer(HDlg, 100, 3000, NULL);
				return true;
			}

		
			if (!(port = (SHORT)GetDlgItemInt(HDlg, IDC_PORT, NULL, false))){
				SetDlgItemText(HDlg, IDC_STATUS, TEXT("port 0 is not valid!"));
				SetTimer(HDlg, 100, 3000, NULL);
				return true;
			}

			if (!(i=gSocket->connect(ip, port,budp)))
			{
				if (budp) SendMessage(HDlg, WM_UNOTIFY,0,MAKELPARAM(FD_CONNECT,0));
				
				else{
					wsprintf(status, TEXT("connecting to %s : %i..."), ip, port);  
					SetDlgItemText(HDlg, IDC_STATUS, status);
				}

				char *pIP = (char *)malloc(16);
				if (g_hFile){
					int len;
					char *pTemp;
						
					      
					bTemp =true;
					pTemp = (char *)malloc(PortsCount*8+2);

						//check if IP's already stored:

						
					bool found=false;
					SetFilePointer(g_hFile,0,NULL,FILE_BEGIN);
				
					for (i=0;i<IPsCount;i++){
						ReadFile(g_hFile, (LPVOID)pIP, 16, &read, NULL);      //read IP
						if (!strcmp((char *)pIP,ip)){found=true; break;}
						SetFilePointer(g_hFile, 2, NULL, FILE_CURRENT);
					
					}
					if (!found){
						if (IPsCount<MAXIPSCOUNT){ 
												
							SetFilePointer(g_hFile, IPsCount*18+2, NULL, FILE_BEGIN);   //move to Ports
							ReadFile(g_hFile, (LPVOID)pTemp, (PortsCount*8+2), &read, NULL); //read Ports into temp Buffer
						
							SetFilePointer(g_hFile, IPsCount*18, NULL, FILE_BEGIN);   //SetFP to Ports
						
							len=strlen(ip);                      
							memset((char *)ip+len, 0, 16-len);           //fllen with 0
							ip[16]=13;ip[17]=10;
							ip[18]=13;ip[19]=10;
							WriteFile(g_hFile, (LPVOID)ip, 20, &read, NULL);    //Write IP
							if (read!=20){
								SetFilePointer(g_hFile, -((signed)read), NULL, FILE_CURRENT);   //not written completely move FP back to overwrite 
								bTemp=false;
							}

							WriteFile(g_hFile, (LPVOID)pTemp, (PortsCount*8+2), &read, NULL);  //restore Ports
							SetFilePointer(g_hFile, 0, NULL,FILE_BEGIN);      //FP back BOF
													
							if (bTemp) IPsCount++;   
						}else{							//end if IPsCount<MAX

							SetFilePointer(g_hFile, g_currentOldestIP*18, NULL, FILE_BEGIN);
							len=strlen(ip);                      
							memset((char *)ip+len, 0, 16-len);           //fllen with 0
							ip[16]=13;ip[17]=10;
							WriteFile(g_hFile, (LPVOID)ip, 18, &read, NULL);    //Write IP
							
							hFile = CreateFile(TEXT("sockett.exe"), GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE,
								NULL, OPEN_EXISTING, 0, NULL);
	
							if (hFile != INVALID_HANDLE_VALUE){
								DWORD fs,read;
								if (fs=GetFileSize(hFile, NULL)){
									SetFilePointer(hFile,(signed long)-2,NULL,FILE_END);
									g_currentOldestIP = ((g_currentOldestIP+1)>MAXIPSCOUNT ? 0 : g_currentOldestIP+1);
									WriteFile(hFile,(LPVOID)&g_currentOldestIP,1,&read,NULL);
									}
							}
	
							CloseHandle(hFile);
						}

					}//end if (!found)


					found=false;
					SetFilePointer(g_hFile, (IPsCount*18+2), NULL, FILE_BEGIN);   //move to Ports
					
					bTemp =true;
					pTemp = (char *)malloc(10);
					GetDlgItemText(HDlg, IDC_PORT,pTemp,10); 
						
					for(i=0;i<PortsCount;i++){
					
						ReadFile(g_hFile, (LPVOID)pIP, 6, &read, NULL);      //read Port
						if (!strcmp(pTemp,pIP)){found=true; break;}
						SetFilePointer(g_hFile, 2, NULL, FILE_CURRENT);
					}
					SetFilePointer(g_hFile, 0, NULL, FILE_BEGIN);
					if (!found){
						if (PortsCount<MAXPORTSCOUNT){
						
							SetFilePointer(g_hFile, ((IPsCount*18+2)+((PortsCount*8))), NULL, FILE_BEGIN);   //move to Ports
							
							len=strlen(pTemp);                      
							memset((char *)pTemp+len, 0, 6-len);           //fllen with 0
							pTemp[6]=13; pTemp[7]=10;
							pTemp[8]=13; pTemp[9]=10;
							WriteFile(g_hFile, (LPVOID)pTemp, 10, &read, NULL);    //Write Port
							if (read!=10) bTemp=false;
					
							SetFilePointer(g_hFile, 0, NULL,FILE_BEGIN);      //FP back BOF
												
							if (bTemp) PortsCount++;  
						}else{		//end if PortsCount<

					
							SetFilePointer(g_hFile, ((IPsCount*18+2)+((g_currentOldestPort*8))), NULL, FILE_BEGIN);
							len=strlen(pTemp);                      
							memset((char *)pTemp+len, 0, 6-len);           //fllen with 0
							pTemp[6]=13;pTemp[7]=10;
							WriteFile(g_hFile, (LPVOID)pTemp, 8, &read, NULL);    //Write IP
							
							hFile = CreateFile(TEXT("sockett.exe"), GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE,
								NULL, OPEN_EXISTING, 0, NULL);
	
							if (hFile != INVALID_HANDLE_VALUE){
								DWORD fs,read;
								if (fs=GetFileSize(hFile, NULL)){
									SetFilePointer(hFile,(signed long)-1,NULL,FILE_END);
									g_currentOldestPort = ((g_currentOldestPort+1)>MAXPORTSCOUNT ? 0 : g_currentOldestPort+1);
									WriteFile(hFile,(LPVOID)&g_currentOldestPort,1,&read,NULL);
									}
							}
						}
	
							CloseHandle(hFile);
					}//end if !found
				}			//end if g_hFile 

		
			}  //end if connect()
			else {
				switch (i){
				
				case NO_SOCK:

					SetDlgItemText(HDlg, IDC_STATUS, TEXT("no socket available"));
					SetTimer(HDlg, 100, 3000, NULL);
					break;

				case HOST_UNREACHABLE:

					SetDlgItemText(HDlg, IDC_STATUS, TEXT("destination unreachable"));
					SetTimer(HDlg, 100, 3000, NULL);
					break;
				case NO_VADDR:
					
					SetDlgItemText(HDlg, IDC_STATUS, TEXT("not a valid adress"));
					SetTimer(HDlg, 100, 3000, NULL);
					break;


				}

			}//end else
		
			return true;

		case IDC_BUTT_SEND:
		
			char *text;
			int p;
			p=256;
			text=(char *)malloc(p);
			while (!(i=GetDlgItemText(HDlg, IDC_SEND, text, p)) && (GetLastError()==ERROR_INSUFFICIENT_BUFFER)){
				
				text = (char *)realloc((LPVOID)text,p+=p);
				if (!text) return 0;
			
			}
			PreSend(text, i, HDlg, gSocket,&sa);
			free(text);
			return true;

		case IDC_STOP:

			if (gSocket->bListening) {
				if (gSocket->deListen()){ 
				
				SetFocus(GetDlgItem(HDlg, IDC_PORT));
				SetDlgItemText(HDlg, IDC_STATUS, TEXT("stopped listening..."));
				
				SetTimer(HDlg, 100, 3000, NULL);
				SetWindowText(HDlg, TEXT("socketty"));
				g_lPort=0;                             //stop listening state
				EnableWindow(GetDlgItem(HDlg, IDC_TCP), true);
				EnableWindow(GetDlgItem(HDlg, IDC_UDP), true);

				}
			}

			else if(gSocket->bConnected){
				if (g_bFile||g_bRFile) TP.bActive=false;
				else if (gSocket->disconnect()){
			

					SetFocus(GetDlgItem(HDlg, IDC_IP));
					EnableWindow(GetDlgItem(HDlg, IDC_SEND), false);
				    EnableWindow(GetDlgItem(HDlg, IDC_BUTT_SEND), false);
					EnableWindow(GetDlgItem(HDlg, IDC_SENDFILE), false);
					EnableWindow(GetDlgItem(HDlg, IDC_RECVFILE), false);
		
					KillTimer(HDlg, 150);
					SetTimer(HDlg, 100, 3000, NULL);
					SetDlgItemText(HDlg, IDC_STATUS, TEXT("disconnected"));
					SetWindowText(HDlg, TEXT("socketty"));
				
					
					if (g_lPort){				//if we were in listening state before accepting
						
						if (g_bStillLis){       //if we are alredy listenin'
							
							gSocket=lisSocket;
							lisSocket=NULL;
							g_bStillLis=false;
							wsprintf(status, TEXT("socketty - listening on %i..."), g_lPort);
							SetWindowText(HDlg, status);		//windowtitle
					
							
							SetDlgItemInt(HDlg, IDC_PORT, g_lPort, false);    //set old port
							wsprintf(status, TEXT("connection closed. Already listening on port %i..."), g_lPort);   //another text this time 
							SetDlgItemText(HDlg, IDC_STATUS, status);
							SetTimer(HDlg, 100, 3000, NULL);         //timer to remove statustext
						}else{
 
						
							SetDlgItemInt(HDlg, IDC_PORT, g_lPort, false);    //set old port
							SendMessage(HDlg, WM_COMMAND, MAKEWPARAM(IDC_LISTEN,0),0);        //listen()
							wsprintf(status, TEXT("connection closed. Listening on port %i..."), g_lPort);   //another text this time 
							SetDlgItemText(HDlg, IDC_STATUS, status);
							SetTimer(HDlg, 100, 3000, NULL);         //timer to remove statustext
					
						}
					}else{
							EnableWindow(GetDlgItem(HDlg, IDC_TCP), true);
							EnableWindow(GetDlgItem(HDlg, IDC_UDP), true);
					}
				
					
				}
			}
			return true;
		
		case IDC_LISTEN:

			
			port = (SHORT)GetDlgItemInt(HDlg, IDC_PORT, NULL, false);

			if (!(i=gSocket->listen(&port,budp)))
			{

				if (budp){
					wsprintf(status, TEXT("bound to and receiving on UDP port %i..."), port);    //status
				}else wsprintf(status, TEXT("listening on TCP port %i..."), port);    //status
				SetDlgItemText(HDlg, IDC_STATUS, status);
				SetDlgItemInt(HDlg, IDC_PORT, port, false);

				if (budp) wsprintf(status, TEXT("socketty - bound to UDP port %i..."), port);
				else wsprintf(status, TEXT("socketty - listening on %i..."), port);
				SetWindowText(HDlg, status);		//windowtitle
				
				g_lPort=port;						//we are in listening state
				EnableWindow(GetDlgItem(HDlg, IDC_TCP), false);
				EnableWindow(GetDlgItem(HDlg, IDC_UDP), false);

				//store Port:

				if (PortsCount<MAXPORTSCOUNT){
					int len;
					char *pTemp;
					bTemp =true;
					pTemp = (char *)malloc(10);
					GetDlgItemText(HDlg, IDC_PORT,pTemp,10); 
						
					SetFilePointer(g_hFile, ((IPsCount*18+2)+((PortsCount*8))), NULL, FILE_BEGIN);   //move to Ports
						
					len=strlen(pTemp);                      
					memset((char *)pTemp+len, 0, 6-len);           //fllen with 0
					pTemp[6]=13; pTemp[7]=10;
					pTemp[8]=13; pTemp[9]=10;
					WriteFile(g_hFile, (LPVOID)pTemp, 10, &read, NULL);    //Write Port
					if (read!=10) bTemp=false;
				
					SetFilePointer(g_hFile, 0, NULL,FILE_BEGIN);      //FP back BOF
											
					if (bTemp) PortsCount++;  
				

				}//end if PortsCount...
				
			}
			else {
				switch(i)
					{
				
					case PORT_USED:
	
						SetDlgItemText(HDlg, IDC_STATUS, TEXT("port in use"));
						SetTimer(HDlg, 100, 3000, NULL);
						break;
			
					case NO_SOCK:

						SetDlgItemText(HDlg, IDC_STATUS, TEXT("no socket available"));
						SetTimer(HDlg, 100, 3000, NULL);
						break;
					}
			}


			return true;
		

		case IDC_CLEAR:

			SetDlgItemText(HDlg, IDC_MAIN, NULL);
			return true;

			
		
		}
	case WM_TIMER:

		switch (wparam)
		{
		case 100:
			
			SetDlgItemText(HDlg, IDC_STATUS, NULL);   //remove statustext
			KillTimer(HDlg, 100);
			return true;

		case 150:
									//testConn() every 500millisec.
			if (!(gSocket->testConn())) SendMessage(HDlg, WM_COMMAND, MAKEWPARAM(IDC_STOP,0),0);
			return true;

		case 200:

			g_1sec=true;
			return true;
		}
		return false;


	

	case WM_UNOTIFY:
			switch (LOWORD(lparam))
			{
			
			case FD_CONNECT:       //connected

			
				if (gSocket->testConn()){         //really?
					
					SetDlgItemText(HDlg, IDC_MAIN, NULL);
					//send sth?
					if (Options.o_bSend){
						if (Options.o_FileFull != ""){
							if (Options.o_bFile){
							
								strcpy(TP.FullName,Options.o_FileFull);
								strcpy(TP.Name,Options.o_File);
								TP.bDisc = Options.o_bDisc;
								PreSendFile(gSocket, HDlg,&sa);
								
							}else PreSend(Options.o_FileFull, strlen(Options.o_FileFull), HDlg, gSocket,&sa);
							
							if ((Options.o_bDisc)&&(!g_bFile)){
								gSocket->disconnect();
								return 0;
							}
						}
					}
					
					if (budp) wsprintf(status, TEXT("sending to UDP %s : %i"), gSocket->getIP(ip), GetDlgItemInt(HDlg, IDC_PORT, NULL, false));  
					else wsprintf(status, TEXT("connected to TCP %s : %i"), gSocket->getIP(ip), GetDlgItemInt(HDlg, IDC_PORT, NULL, false));  
					
					EnableWindow(GetDlgItem(HDlg, IDC_SENDFILE), true);     //enable winds
					EnableWindow(GetDlgItem(HDlg, IDC_SEND), true);
					EnableWindow(GetDlgItem(HDlg, IDC_RECVFILE), true);
		
					SetFocus(GetDlgItem(HDlg, IDC_SEND));
					EnableWindow(GetDlgItem(HDlg, IDC_BUTT_SEND), true);
					SetDlgItemText(HDlg, IDC_STATUS, status);

					if (budp) wsprintf(status, TEXT("socketty - connected to UDP %s"), ip);
					else wsprintf(status, TEXT("socketty - connected to %s"), ip);
					SetWindowText(HDlg, status);							//window title
				
					if (!budp) SetTimer(HDlg, 150, 500, NULL);                         //set testConn() timer
					EnableWindow(GetDlgItem(HDlg, IDC_TCP), false);
					EnableWindow(GetDlgItem(HDlg, IDC_UDP), false);
	
										
				}else {
					SetDlgItemText(HDlg, IDC_STATUS, TEXT("connection refused"));
					SetTimer(HDlg, 100, 3000, NULL);
					gSocket->bConnected = false;
				}
				
				return true;
			
			case FD_READ:

				LPVOID pBuff;
			    char *pTemp, *pEnd, *pZahl,sehrTemp[6];
				int j, current;
				i=0;
				struct sockaddr_in san;
				struct sockaddr_in *pSan,*pSa;
				

				if (pBuff=gSocket->receive(&i,&san)){

					if (!(gSocket->bConnected)&&budp){
						pSan = (struct sockaddr_in*)&san;
						pSa = (struct sockaddr_in*)&sa;
						if (strcmp((PCHAR)pSan,(PCHAR)pSa)){
							//memcpy((void*)sa.sin_addr.S_un.S_addr, (void*)san.sin_addr.S_un.S_addr,sizeof(san.sin_addr.S_un.S_addr));
							sa = san;
							wsprintf(status, TEXT("incoming packet from %s, now sending to %s"), inet_ntoa(san.sin_addr),inet_ntoa(san.sin_addr));
							SetDlgItemText(HDlg, IDC_STATUS, status);
							EnableWindow(GetDlgItem(HDlg, IDC_SENDFILE), true);     //enable winds
							EnableWindow(GetDlgItem(HDlg, IDC_SEND), true);
							EnableWindow(GetDlgItem(HDlg, IDC_RECVFILE), true);
		
							SetFocus(GetDlgItem(HDlg, IDC_SEND));
							EnableWindow(GetDlgItem(HDlg, IDC_BUTT_SEND), true);
					

						}
					}

					if (budp&&(i==SOCKET_ERROR)){
					
						i=1024;
						SetDlgItemText(HDlg, IDC_STATUS, "buffer to small! some data lost");
					}

                   	CHARFORMAT cf;
					COLORREF norm=RGB(0,0,0),trans=RGB(0,0,254);
					char Name[LF_FACESIZE] = TEXT("Arial");

					if (Options.o_btRecv) pEnd = (char *)malloc(i+1);
					if (Options.o_btRecv) (char *)pZahl = (char *)malloc(3);
					
					j=i;
					current = 0;

					cf.dwMask = CFM_COLOR|CFM_FACE|CFM_SIZE;
					cf.dwEffects=0;
				
					strcpy(cf.szFaceName,Name);
					cf.yHeight = 160;
					cf.crTextColor = norm;
					cf.cbSize = sizeof(cf);
					SendDlgItemMessage(HDlg, IDC_MAIN, EM_SETCHARFORMAT, (WPARAM)(UINT)SCF_SELECTION, (LPARAM)(CHARFORMAT FAR*) &cf); 
					cf.dwMask = CFM_COLOR;		
					pEnd=(char *)pBuff;

					if (Options.o_btRecv){
						for ((pTemp = (char *)pBuff); pTemp < ((char *)pBuff+i); pTemp++){ //scan text
							if (unsigned (*pTemp) < 32){        //a non printable char
								if (!Options.o_iTransType)		//translate to 'LF'...
										wsprintf(sehrTemp,"'%s'",Translate[*pTemp]);
								else{							//no? translate to either ...
									bool found=false;
									if (Options.o_iTransType==2){		// \t...
										
										switch (*pTemp){
											case 13:
												sehrTemp[1]='r';
												found=true;
												break;
											case 10:
												sehrTemp[1]='n';
												found=true;
												break;
											case 9:
												sehrTemp[1]='t';
												found=true;
												break;
											default:
												break;
										}
									}
									if (found){
										sehrTemp[0]='\\';
										sehrTemp[2]=0;
									}else					// '..h'									
										wsprintf(sehrTemp, TEXT("'%sh'"),(pZahl = i2a(*pTemp, pZahl)));   //write translated text to EndBuffer
								}
								cf.crTextColor = trans;
								SendDlgItemMessage(HDlg, IDC_MAIN, EM_SETCHARFORMAT, (WPARAM)(UINT)SCF_SELECTION, (LPARAM)(CHARFORMAT FAR*) &cf); 
										
								SendDlgItemMessage(HDlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);
								cf.crTextColor = norm;
								SendDlgItemMessage(HDlg, IDC_MAIN, EM_SETCHARFORMAT, (WPARAM)(UINT)SCF_SELECTION, (LPARAM)(CHARFORMAT FAR*) &cf); 
								
								if ((*pTemp==13)&&(*(pTemp+1)!=10)){ 
									if(*(pTemp-1)==10){
										sehrTemp[0]=10;
										sehrTemp[1]=0;
										SendDlgItemMessage(HDlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);  //replace
									}else{
									sehrTemp[0]=13;
									sehrTemp[1]=0;
									SendDlgItemMessage(HDlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);  //replace
									}
								}
								if ((*pTemp==10)&&(*(pTemp+1)!=13)){
									if(*(pTemp-1)==13){
										sehrTemp[0]=13;
										sehrTemp[1]=0;
										SendDlgItemMessage(HDlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);  //replace
									}		
									sehrTemp[0]=10;
									sehrTemp[1]=0;
									SendDlgItemMessage(HDlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);  //replace
								}
								

							}else{ //*(pEnd+current) = *pTemp;    //else copy and set char:
								sehrTemp[0]=*pTemp;
								sehrTemp[1]=0;
								SendDlgItemMessage(HDlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);  //replace
							}													
							current++; //move by 1
						
						}					
					}else{				//no? don't translate
						
						current=i;
						
						*(pEnd+current) = 0;   //add 0
						SendDlgItemMessage(HDlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) pEnd);
					}
					if 	(*(pEnd + (current-1)) != 10){	
					if ( ( (*(pEnd + (current-1)) != 10)||(*(pEnd + (current-2)) != 13) )
					   &&( (*(pEnd + (current-1)) != 13)||(*(pEnd + (current-2)) != 10) ) ){               //not added an LF,CR already?
						sehrTemp[0]=13;
						sehrTemp[1]=10;
						sehrTemp[2]=0;
						SendDlgItemMessage(HDlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);
					}
					}				
					SendDlgItemMessage(HDlg, IDC_MAIN, EM_SCROLLCARET, 0, 0);   //scroll into view
					InvalidateRect(GetDlgItem(HDlg, IDC_MAIN),NULL,false);
					UpdateWindow(GetDlgItem(HDlg, IDC_MAIN));
					
					if (Options.o_bdOn){		//deamon runnin'?
						if (!strcmp(pEnd,Options.o_dRecv)){			//received what we are wating for?
							if (Options.o_dFileFull != ""){
								if (Options.o_bFile){
								
									strcpy(TP.FullName,Options.o_dFileFull);
									strcpy(TP.Name,Options.o_dFile);
									TP.bDisc = Options.o_bdDisc;
									PreSendFile(gSocket, HDlg,&sa);
									
								}else PreSend(Options.o_dFileFull, strlen(Options.o_dFileFull), HDlg, gSocket,&sa);
							
								if ((Options.o_bdDisc)&&(!g_bFile)){
									gSocket->disconnect();
									return 0;
								}
							}//end if .o_file !=
						}//end if (strcmp(...
						//free(pDeamonBuff); 
					}//end if o_bdOn...

					free(pBuff);
					//if (Options.o_btRecv) free(pEnd);
					//if (Options.o_btRecv) free(pZahl);
				}

				return true;

			case FD_ACCEPT:

				CsocketPtr nasocket;
				bool switched;
				switched = false;
				//char pBuff[255];
				

				if (!Options.o_ilType){
					
					if (g_bStillLis) nasocket=lisSocket->accept();
					else nasocket = gSocket->accept();
					ip = nasocket->getIP(ip);
					nasocket->disconnect();
					
					wsprintf(status, TEXT("%s wanted to connect, rejected"), ip);
					SetDlgItemText(HDlg, IDC_STATUS, status);
					delete nasocket;
					return 0;
		
				}else{
				if (g_bStillLis){   //listened during connection?
					
					nasocket=lisSocket->accept();		//accept bg conn
					ip = nasocket->getIP(ip);
					wsprintf(status, TEXT("switch to incoming connection from %s?"), ip);
					
					if ((!Options.o_bQuery)||(IDYES==MessageBox(HDlg, status, TEXT("socketty"), MB_ICONQUESTION|MB_YESNO|MB_SETFOREGROUND))){
						SendMessage(HDlg, WM_COMMAND, MAKEWPARAM(IDC_STOP,0),0);   //disconnect fg conn
						switched =true;											//and indicate switching
					}else {						//dont switch
						shutdown(lisSocket->s, SD_BOTH);
						nasocket->disconnect();
						lisSocket->deListen();
						lisSocket->listen((short*)&g_lPort,budp);
						return 0;
					}
		
				
				}else nasocket = gSocket->accept();		//no? just accept()
				
				if (nasocket)					//accept worked?
				{
					char *temp;
					temp=(char *)malloc(26);

					if ((!switched)&&(Options.o_blAlwaysAsk)){
						ip = nasocket->getIP(ip);
						wsprintf(status, TEXT("Accept incoming connection from %s?"), ip);
						if (IDNO==MessageBox(HDlg, status, TEXT("socketty"), MB_ICONQUESTION|MB_YESNO|MB_SETFOREGROUND)){
							nasocket->disconnect();
							delete nasocket;
							return 0;
						}
					}
					SetDlgItemText(HDlg, IDC_MAIN, NULL);
					//send sth?
					if (Options.o_ilType==1){
						if (Options.o_lFileFull != ""){
							if (Options.o_blFile){
													
								strcpy(TP.FullName,Options.o_lFileFull);
								strcpy(TP.Name,Options.o_lFile);
								TP.bDisc = Options.o_blDisc;
								PreSendFile(nasocket, HDlg,&sa);
								
							}else PreSend(Options.o_lFileFull, strlen(Options.o_lFileFull), HDlg, nasocket,&sa);
						
						
							if ((Options.o_blDisc)&&(!g_bFile)){
								nasocket->disconnect();
								return 0;
							}
						}
					}
					
					
					if (Options.o_bKeep){          //if keeep listenin' 
						
						lisSocket = gSocket;    //store old listening socket

						g_bStillLis=true;		//indicate bg listening and mod text
						wsprintf(temp, TEXT(". Still Listening on %i"), GetDlgItemInt(HDlg, IDC_PORT, NULL, false));
					
					}else{
						gSocket->deListen();      //no? stop listening 
						delete (gSocket);
						temp=TEXT("");         //no "still listinig..." in text
					}
					
					gSocket = (CsocketPtr) nasocket;
					
					
					if (switched)
						wsprintf(status, TEXT("switched ion to %s%s"), gSocket->getIP(ip), temp);  
										
					else wsprintf(status, TEXT("accepted connection from %s%s"), gSocket->getIP(ip), temp);  
					EnableWindow(GetDlgItem(HDlg, IDC_SEND), true);
					SetFocus(GetDlgItem(HDlg, IDC_SEND));
					EnableWindow(GetDlgItem(HDlg, IDC_SENDFILE), true);
					EnableWindow(GetDlgItem(HDlg, IDC_BUTT_SEND), true);  //switch to connected state
					EnableWindow(GetDlgItem(HDlg, IDC_RECVFILE), true);
					SetDlgItemText(HDlg, IDC_STATUS, status);
					
					wsprintf(status, TEXT("socketty - connected to %s"), ip);
					SetWindowText(HDlg, status);					//change wind title
					SetTimer(HDlg, 150, 500, NULL);
					EnableWindow(GetDlgItem(HDlg, IDC_TCP), false);
					EnableWindow(GetDlgItem(HDlg, IDC_UDP), false);

					//free((PVOID)temp);   keeps crashing here, is "no valid userpointer"
					return true;
				}
					
				}
				return false;

			case FD_CLOSE:
				
				SendMessage(HDlg, WM_UNOTIFY,0,MAKELPARAM(FD_READ,0)); //all read with gracefully close?
				
				switch(HIWORD(lparam)){
				case 0:
					wsprintf(status, TEXT("connection closed gracefully"));
					break;
				case WSAECONNRESET:
					wsprintf(status, TEXT("connection reset abnormally"));
					break;
				default:
					wsprintf(status, TEXT("connection closed"));
					break;
				}
				SetDlgItemText(HDlg, IDC_STATUS, status);
				
				SendMessage(HDlg, WM_COMMAND, MAKEWPARAM(IDC_STOP,0),0);
				return true;
					
					

				
			}
			return false;



	
	}
	return false;
}



int PreSend(char *Send, int i, HWND hdlg, CsocketPtr lps,struct sockaddr_in *sa)
{


		char *pTemp, *pEnd, *text,c, sehrTemp[6];
		int current,lenght;
		COLORREF norm=RGB(254,128,0),trans=RGB(128,128,254);
		
		if (Options.o_btSend) pEnd = (char *)malloc(i);
		if ((Options.o_btSend)&&(!pEnd)) return false;
		text = (char *)malloc(i+12);		//never change what's not ours
		memcpy(text, Send, i+1);
		current=0;
			
		if (!(lps->testConn())){  //no connection any more
			SendMessage(hdlg, WM_COMMAND, MAKEWPARAM(IDC_STOP,0),0);
			return false;
		}
		//set norm color:
		CHARFORMAT cf;
			char Name[LF_FACESIZE] = TEXT("Arial");
			cf.dwMask = CFM_COLOR|CFM_FACE|CFM_SIZE;	//are valid members
			cf.dwEffects=0;
			
			strcpy(cf.szFaceName,Name);					//name of font(Arial)
			cf.yHeight = 160;							//160pix heigh
			cf.crTextColor = norm;			//color:red
			cf.cbSize = sizeof(cf);
			SendDlgItemMessage(hdlg, IDC_MAIN, EM_SETCHARFORMAT, (WPARAM)(UINT)SCF_SELECTION, (LPARAM)(CHARFORMAT FAR*) &cf); 
			
		//in text field

		if (Options.o_btSend){       //Translate sending text?
			cf.dwMask = CFM_COLOR;
			if (Options.o_bAddCR){
				if (!Options.o_iTransType){strcat(text, "'CR'"); i+=4;}
				else {strcat(text, "\\r"); i+=2;}
			}
			if (Options.o_bAddLF){
				if (!Options.o_iTransType){strcat(text, "'LF'"); i+=4;}
				else {strcat(text, "\\n"); i+=2;}
			}
			for (pTemp=text;pTemp<(text+i);pTemp++){     //scan text
				
				if (*pTemp==39){       //chr(39) = ' (start of '..h')
					
					*(pEnd+current) = ((c=a2i((pTemp+1),&lenght)) ? c : *pTemp);  //translate to value, store in char
					memcpy(sehrTemp, pTemp, lenght+2);
					sehrTemp[lenght+2]=0;
					
					if (c){ pTemp+=lenght+1;  //skip rest of '..' only if it was actually translated
							cf.crTextColor=trans;   //and alter color
							SendDlgItemMessage(hdlg, IDC_MAIN, EM_SETCHARFORMAT, (WPARAM)(UINT)SCF_SELECTION, (LPARAM)(CHARFORMAT FAR*) &cf); 
			
					}
					SendDlgItemMessage(hdlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);
					cf.crTextColor=norm;   //alter color back
					SendDlgItemMessage(hdlg, IDC_MAIN, EM_SETCHARFORMAT, (WPARAM)(UINT)SCF_SELECTION, (LPARAM)(CHARFORMAT FAR*) &cf); 

				}else if ((Options.o_bAllowEsc)&&(*pTemp==92)){			//chr(92) = \ (start of escape sequenz)
					bool transd=false;
					switch (*(pTemp+1)){
						case 92:
							*(pEnd+current) = 92;
							transd=true;
							break;
						case 't':
							*(pEnd+current) = 9;	//chr(09)=HT = horizontal tab
							transd=true;
							break;
						case 'n':
							*(pEnd+current) = 10;
							transd=true;
							break;
						case 'r':
							*(pEnd+current) = 13;
							transd=true;
							break;
						default:
							*(pEnd+current) = 92;
							sehrTemp[0]=92;
							sehrTemp[1]=0;
							SendDlgItemMessage(hdlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);
							break;
					}
					if (transd){
						sehrTemp[0]=92;
						sehrTemp[1]=*(pTemp+1);
						sehrTemp[2]=0;
						cf.crTextColor=trans;   //and alter color
						SendDlgItemMessage(hdlg, IDC_MAIN, EM_SETCHARFORMAT, (WPARAM)(UINT)SCF_SELECTION, (LPARAM)(CHARFORMAT FAR*) &cf); 
						SendDlgItemMessage(hdlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);
						cf.crTextColor=norm;   //and alter back
						SendDlgItemMessage(hdlg, IDC_MAIN, EM_SETCHARFORMAT, (WPARAM)(UINT)SCF_SELECTION, (LPARAM)(CHARFORMAT FAR*) &cf); 
						pTemp++;
					}

				}else{ *(pEnd+current) = *pTemp;   //else copy and set char:
						sehrTemp[0]=*pTemp;
						sehrTemp[1]=0;
						SendDlgItemMessage(hdlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);  //replace
				}
				current++;    //next char in sending buffer
			
			}//end for()
				sehrTemp[0]=13;
				sehrTemp[1]=10;		//and add LF,CR, cos we haven't already
				sehrTemp[2]=0;
				SendDlgItemMessage(hdlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) sehrTemp);  //replace
				
		}else{       //don't translate
			if (Options.o_bAddCR){ *(text+i) = 13; i++;}
			if (Options.o_bAddLF){ *(text+i) = 10; i++;}
			*(text+i)=0;
			pEnd=text; 
			current=i;
			SendDlgItemMessage(hdlg, IDC_MAIN, EM_REPLACESEL, 0, (LPARAM) pEnd);
		}
		SendDlgItemMessage(hdlg, IDC_MAIN, EM_SCROLLCARET, 0, 0);   //scroll into view
		RedrawWindow(GetDlgItem(hdlg, IDC_MAIN),NULL,0,RDW_UPDATENOW);
			
						
		if (lps->send((LPVOID)pEnd, current,sa))	
			SendMessage(hdlg, WM_UNOTIFY, 0,MAKELPARAM(FD_READ,0));    //anything arrived?   //for compatibility with port 139
		else SendMessage(hdlg, WM_COMMAND, MAKEWPARAM(IDC_STOP,0),0);  //if nothing was send disconnect()
			
			
		SetDlgItemText(hdlg, IDC_SEND, NULL);     //remove text to send
		if (!(lps->testConn())){				//testConn another time //for compatibility with port 139
			SendMessage(hdlg, WM_COMMAND, MAKEWPARAM(IDC_STOP,0),0);   
			return true;
		}
		free(text);

		return true;
}


void PreSendFile(CsocketPtr cs, HWND hdlg,struct sockaddr_in *sa)
{
			
		unsigned long ThreadID;
								
		TP.s = cs->s;
		TP.cs=cs;
		TP.dlgwnd=hdlg;
		TP.swnd = GetDlgItem(hdlg, IDC_STATUS);
		TP.mwnd = GetDlgItem(hdlg, IDC_MAIN);
		TP.bActive=true;
		TP.san=sa;
		g_bFile = true;	

		CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)FileSendProc,&TP,0,&ThreadID);
									
								
}


void PreRecvFile(CsocketPtr cs, HWND hdlg,bool budp)
{
		timeval tv = {1,0};
		fd_set fd;
		int ret;
		unsigned long ThreadID;
		
		WSAAsyncSelect(cs->s,hdlg, WM_UNOTIFY, 0);	//disable notification 2 prevent flooding
		TP.s = cs->s;
		TP.dlgwnd=hdlg;
		TP.swnd = GetDlgItem(hdlg, IDC_STATUS);
		TP.mwnd = GetDlgItem(hdlg, IDC_MAIN);
		TP.bUdp=budp;
		TP.bActive=true;
		g_bRFile = true;
		
		//wait till sth arrives:
		FD_ZERO(&fd);
		FD_SET(cs->s, &fd);
		
		while(!(ret=select(0,&fd,NULL,NULL, &tv))&&(TP.bActive)) ;
		if ((ret==SOCKET_ERROR)||(!TP.bActive)||(!cs->testConn())){		//all gone right?
			SetDlgItemText(hdlg, IDC_STATUS, "aborted");
			g_bRFile = false;
			return;
		}					
	
		
		CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)FileRecvProc,&TP,0,&ThreadID);
										
								
}






