/*						Filesend.cpp: Filesend proc() as well as my i2a and a2i procs

	This file is not distributed under the GNU public license (I dont know what that is anyway), 
	it is absolutely free.
	As long as you are maintainig some note that you stole this code from me, you are allowed to use it.

	derDoc																		derDoc@gmx.net
																		members.xoom.com/derDoc
*/





#include "StdAfx.h"
#include "Options.h"
#include "Csocket.h"
#include "sockett.h"
#include "resource.h"
#include "selbst.h"




extern OPTIONS Options;
extern THREADPARAMS TP;
extern bool g_bFile,g_bRFile;
extern char *Translate[];



DWORD WINAPI FileSendProc(PVOID pP)
{

	HANDLE hFile;
	CsocketPtr cs;
	DWORD fs, fsHigh, read, tc,tcp,tcp1,sent;
	signed __int64 size,allsent=0;
	LPVOID pBuff = malloc(Options.o_iPacketSize+1);
	THREADPARAMS *tP = (THREADPARAMS *)pP;
	char text[300], ks[30]=TEXT("");
	bool breaked=true;
	KillTimer(tP->dlgwnd, 150); //temporarily deactivate testConn() timer, cause select will claim that s is not ready for writin'
	

	hFile = CreateFile(tP->FullName, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE,
			NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (hFile != INVALID_HANDLE_VALUE){
		fs = GetFileSize(hFile, &fsHigh);
		if (fs==-1) size=0;
		else size=(((fsHigh<<32)+fs));
		g_bFile=true;
		tc=GetTickCount();

			while ((ReadFile(hFile, pBuff, Options.o_iPacketSize, &read, NULL))&&(tP->bActive)){
				
				if (!read){ breaked=false; break;}
				
				sent=0;

				tcp=GetTickCount();
				cs=tP->cs;

				while (sent+=cs->send((void *)((char *)pBuff+sent), (read-sent), tP->san) < read)
					Sleep(Options.o_iSendWait);
				tcp1 = GetTickCount();

				if (!Options.o_bQuiet){
					*((char *)pBuff+(Options.o_iPacketSize+1))=0;
					SendMessage(tP->mwnd, EM_REPLACESEL, 0, (LPARAM) pBuff);
					SendMessage(tP->mwnd, EM_SCROLLCARET, 0, 0);
				}
				
				allsent+=sent;

				/*if (g_1sec) {
					wsprintf(ks, TEXT("at %d.%dk/s)"), (unsigned)((SecSent*Options.o_iPacketSize)/1024), (unsigned)((SecSent*Options.o_iPacketSize)%1024));
					SecSent=0;
					g_1sec=false;
				}*/

				wsprintf(text, TEXT("sending %s: %dbyte/%dbyte (%d%% done, at %ib/s)"), tP->Name, 
					(unsigned int)allsent,(unsigned int)size, ((allsent*100)/size),
					(unsigned int)((float)sent/(float)(tcp1-tcp)));
					//(unsigned int)((float)sent/((float)(tcp1-tcp)/1000)));  
				SetWindowText(tP->swnd, text);

			}
		
	}
	if (breaked) {
		if (tP->bActive){
		
			wsprintf(text,"sending failed due to read error... (%i.%i k sent)",((unsigned)allsent/1024), ((unsigned)allsent%1024));
			SetWindowText(tP->swnd, text);
		}else{
			DWORD tn=GetTickCount();
			int tempcp=(int)((float)(allsent)/(float)((tn-tc)/1000))/1024;
			int tempcp1=(int)((float)(allsent)/(float)((tn-tc)/1000))%1024;

			__int64 tempp=(__int64)(allsent*100)/size;

			wsprintf(text, TEXT("aborted, %i.%ik sent(%i%%) (%i.%i secs. elapsed, at %i.%ik/s)"), ((unsigned)allsent/1024), ((unsigned)allsent%1024),
			tempp,
			(int)((tn-tc)/1000),(int)((tn-tc)%1000),
			tempcp,tempcp1);
			SetWindowText(tP->swnd, text);
		}
	}else {
		DWORD tn=GetTickCount();	
		
		wsprintf(text, TEXT("%d.%dk sent (%d.%d secs. elapsed, at %d.%dk/s)"), ((unsigned)allsent/1024), ((unsigned)allsent%1024),
			(tn-tc)/1000,(tn-tc)%1000, 
			(int)((float)allsent/((float)(tn-tc)/1000))/1024,
			(int)((float)allsent/((float)(tn-tc)/1000))%1024 ); 
			//((unsigned int)((((float)((float)alsent*(float)Options.o_iPacketSize)/1024)/((float)((float)tn-(float)tc)/1000))*10000))%10000);  
	//kinda' complex lookin'
			
			SetWindowText(tP->swnd, text);
	}
	
	tP->bActive=false;
	CloseHandle(hFile);
	if (TP.bDisc) SendMessage(TP.dlgwnd, WM_COMMAND, MAKEWPARAM(IDC_STOP,0),0);
	else SetTimer(tP->dlgwnd, 150, 500, NULL);   //reactivate TestConn() timer
	g_bFile=false;
	
	ExitThread(0);
	return 0;
}


DWORD WINAPI FileRecvProc(PVOID pP)
{

	HANDLE hFile;
	DWORD read,tc,tcp,tcp1,written,reado;
	signed __int64 allsent=0;
	LPVOID pBuff=malloc(1024);
	THREADPARAMS *tP = (THREADPARAMS *)pP;
	char text[300], ks[30]=TEXT("");
	bool breaked=false,wait=false;
	KillTimer(tP->dlgwnd, 150); //temporarily deactivate testConn() timer, cause select will claim that s is not ready for writin'
	

	hFile = CreateFile(tP->FullName, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE,
			NULL, CREATE_ALWAYS, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (hFile != INVALID_HANDLE_VALUE){
		
		g_bRFile=true;
		tc=GetTickCount();
		tcp=0;
loop:	
		if (TP.bUdp){
			
			while ((read = recv(tP->s, (char FAR *) pBuff, 1024, 0)) && (read)){ 
				if (!WriteFile(hFile,pBuff,read,&written,NULL))
				{ breaked=true; break;}
			

				if (written<read){	//not written all
					reado=read;		//retry else break
					if ((!WriteFile(hFile,(char*)pBuff+written,reado-=written,&written,NULL))||(written<reado))
						{breaked=true; break;}
				}
				
				if (!Options.o_bQuiet){
					*((char *)pBuff+read+1)=0;
					SendMessage(tP->mwnd, EM_REPLACESEL, 0, (LPARAM) pBuff);
					SendMessage(tP->mwnd, EM_SCROLLCARET, 0, 0);
				}
				tcp1=GetTickCount();
				wsprintf(text, TEXT("receiving %s: %dbyte (at %ib/s)"), tP->Name, 
					(unsigned int)allsent,
					(unsigned int)((float)read/(float)(tcp1-tcp)));
					//(unsigned int)((float)sent/((float)(tcp1-tcp)/1000)));  
				SetWindowText(tP->swnd, text);

				allsent+=read;
				tcp=GetTickCount();

			}//end while


		}else{	//TCP				
	
			while (((read = recv(tP->s, (char FAR *) pBuff, 1024, 0)) != SOCKET_ERROR) && (read)){ 

				if (!WriteFile(hFile,pBuff,read,&written,NULL))
				{ breaked=true; break;}
			

				if (written<read){	//not written all
					reado=read;		//retry else break
					if ((!WriteFile(hFile,(char*)pBuff+written,reado-=written,&written,NULL))||(written<reado))
						{breaked=true; break;}
				}
				
				if (!Options.o_bQuiet){
					*((char *)pBuff+read+1)=0;
					SendMessage(tP->mwnd, EM_REPLACESEL, 0, (LPARAM) pBuff);
					SendMessage(tP->mwnd, EM_SCROLLCARET, 0, 0);
				}
				tcp1=GetTickCount();
				wsprintf(text, TEXT("receiving %s: %dbyte (at %ib/s)"), tP->Name, 
					(unsigned int)allsent,
					(unsigned int)((float)read/(float)(tcp1-tcp)));
					//(unsigned int)((float)sent/((float)(tcp1-tcp)/1000)));  
				SetWindowText(tP->swnd, text);

				allsent+=read;
				tcp=GetTickCount();

			}//end while
						
		}//end else
		if ((!read)&&(!wait)){
			wait=true;
			Sleep(2000);
			goto loop;
		}
		
	}else breaked=true; //hfile==INVADLID_FILE

	if (breaked||(!tP->bActive)){
		if (tP->bActive){
			wsprintf(text,"receiving failed due to I/O error... (%d.%dk received)",((unsigned)allsent/1024),((unsigned)allsent%1024));
			SetWindowText(tP->swnd, text);
		}else{
			DWORD tn=GetTickCount();
			wsprintf(text, TEXT("aborted, %d.%dk received (%d.%d secs. elapsed, at %d.%dk/s)"), ((unsigned)allsent/1024), ((unsigned)allsent%1024),
			(tn-tc)/1000,(tn-tc)%1000, 
			(int)((float)allsent/((float)(tn-tc)/1000))/1024,
			(int)((float)allsent/((float)(tn-tc)/1000))%1024 ); 
			SetWindowText(tP->swnd, text);
		}
	}else {
		DWORD tn=GetTickCount();	
		
		wsprintf(text, TEXT("%d.%dk received (%d.%d secs. elapsed, at %d.%dk/s)"), ((unsigned)allsent/1024), ((unsigned)allsent%1024),
			(tn-tc)/1000,(tn-tc)%1000, 
			(int)((float)allsent/((float)(tn-tc)/1000))/1024,
			(int)((float)allsent/((float)(tn-tc)/1000))%1024 ); 
			//((unsigned int)((((float)((float)alsent*(float)Options.o_iPacketSize)/1024)/((float)((float)tn-(float)tc)/1000))*10000))%10000);  
	//kinda' complex lookin'
			
		SetWindowText(tP->swnd, text);
	}

	
	tP->bActive=false;
	CloseHandle(hFile);
	SendMessage(TP.dlgwnd, RECV_STOPPED, 0,0);
	SetTimer(tP->dlgwnd, 150, 500, NULL);   //reactivate TestConn() timer
	g_bRFile=false;
	ExitThread(0);
	return 0;
}

		
		

char *i2a(char zahl, char *pBuff)
{

		*pBuff = (((zahl/16) > 9)? ((zahl/16)+0x41) : ((zahl/16)+0x30));   
		*(pBuff+1) = (((zahl%16) > 9)? ((zahl%16)+0x37) : ((zahl%16)+0x30));
		*(pBuff+2) = '\0';

		return pBuff;
			
}




char a2i(char *pBuff, int *len)
{

	int laenge=0,i;
	*len=0;
	char *temp;
	if (*(pBuff+2)==39) laenge = 1;
	else if (*(pBuff+3)==39) laenge = 2;
	else if (*(pBuff+4)==39) laenge = 3;
	else return 0;

	
	char zahl=0;
	*len=laenge+1;
	temp=(char *)malloc(*len+1);
	if (*(pBuff+laenge)=='d'){

		if (((*pBuff<0x30)||(*pBuff>0x39)) || ((*(pBuff+1)<0x30)||(*(pBuff+1)>0x39))) return 0;

		zahl += ((*pBuff)-0x30)*10 * ((laenge==3)?10:1);
		zahl += (*(pBuff+1)-0x30) * ((laenge==3)?10:1);
		if (laenge==3) zahl += (*(pBuff+2)-0x30);
	
		return (char)zahl;

	}
	else if (*(pBuff+laenge)=='h'){

		if ((*pBuff>0x61)&&(*pBuff<0x67)) *pBuff-=0x20;      //lower char? Uppercase(){
		if ((*(pBuff+1)>0x61)&&(*(pBuff+1)<0x67)) *(pBuff+1)-=0x20;
		if ((laenge==3)&& ((*(pBuff+2)>0x61)&&(*(pBuff+2)<0x67))) *(pBuff+2)-=0x20;	//}
	
		if ((((*pBuff<0x30)||(*pBuff>0x39))&&((*pBuff<0x41)||(*pBuff>0x46))) || 
			(((*(pBuff+1)<0x30)||(*(pBuff+1)>0x39))&&((*(pBuff+1)<0x41)||(*(pBuff+1)>0x46)))) return 0;

		if ((laenge==3)&&(((*(pBuff+2)<0x30)||(*(pBuff+2)>0x39))&&((*(pBuff+2)<0x41)||(*(pBuff+2)>0x46)))) return 0;


		zahl += (((*pBuff>0x039)?(*pBuff-0x037):(*pBuff-0x030)) * 10 * ((laenge==3)?10:1));
		zahl += (((*(pBuff+1)>0x039)?(*(pBuff+1)-0x037):(*(pBuff+1)-0x030)) * ((laenge==3)?10:1));
		if (laenge==3) zahl += ((*(pBuff+2)>0x039)?(*(pBuff+2)-0x037):(*(pBuff+2)-0x030));	
	
		return (char)zahl;

	}
	else{
		strcpy(temp,pBuff);
		*(temp+laenge+1)=0;
		for (i=0;i<32;i++){
			if (!strcmp(temp, Translate[i]))			//yup
				
				return i;
				
		}
	}
	
	return 0;
	
	
}









         



