/*								sheet.cpp: CreatePropertySheet func

	This file is not distributed under the GNU public license (I dont know what that is anyway), 
	it is absolutely free.
	As long as you are maintainig some note that you stole this code from me, you are allowed to use it.

	derDoc																		derDoc@gmx.net
																		members.xoom.com/derDoc
*/

#include "StdAfx.h"
#include "resource.h"
#include "Options.h"


extern OPTIONS Options;

int CALLBACK GeneralDlgProc(HWND HDlg, UINT Msg, WPARAM wparam, LPARAM lparam);
int CALLBACK ListenDlgProc(HWND HDlg, UINT Msg, WPARAM wparam, LPARAM lparam);
int CALLBACK DeamonDlgProc(HWND HDlg, UINT Msg, WPARAM wparam, LPARAM lparam);
int CALLBACK BannDlgProc(HWND HDlg, UINT Msg, WPARAM wparam, LPARAM lparam);



void CreatePropertySheet(HWND hwndParent, HINSTANCE hInst)
{

		PROPSHEETHEADER pshead;
		PROPSHEETPAGE   pspage[4];
		int i;

		// Initialize property sheet HEADER data
	    ZeroMemory (&pshead, sizeof (PROPSHEETHEADER)) ;
		pshead.dwSize  = sizeof (PROPSHEETHEADER) ;
		pshead.dwFlags = PSH_PROPTITLE | PSH_PROPSHEETPAGE | PSH_NOAPPLYNOW;
		pshead.hwndParent  = hwndParent ;
	    pshead.pszCaption  = "Socketty";
		pshead.nPages      = 4;
		pshead.nStartPage  = 0 ;
		pshead.ppsp        = pspage ;
		
		 // Zero out property PAGE data
		ZeroMemory (&pspage, 4* sizeof (PROPSHEETPAGE)) ;

	    //fill in every struct:
		for (i=0;i<4;i++){
			pspage[i].dwSize      = sizeof (PROPSHEETPAGE) ;
			pspage[i].hInstance   = hInst ;
		}
		pspage[0].pfnDlgProc  = GeneralDlgProc;
		pspage[0].pszTemplate = MAKEINTRESOURCE (IDD_GENERAL);
		
		pspage[1].pfnDlgProc  = ListenDlgProc;
		pspage[1].pszTemplate = MAKEINTRESOURCE (IDD_LISTEN);
     	
		pspage[2].pfnDlgProc  = DeamonDlgProc;
		pspage[2].pszTemplate = MAKEINTRESOURCE (IDD_DEAMON);
     	
		pspage[3].pfnDlgProc  = BannDlgProc;
		pspage[3].pszTemplate = MAKEINTRESOURCE (IDD_BANN);
     	
     // --------- Create & display property sheet --------- 
			
		i=PropertySheet(&pshead);
		i=GetLastError();

}


